const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const encargoPage = require('../../../page-objects/parametrizacao/documentos fiscais/encargo.po.js');
const j = require('../../../json/leitorJson.po.js');
const protractorHelper = require('protractor-helper');

const encargoGridId = '10479054442256421411064';


describe('Tela Encargo', () => {
	beforeEach(() => {
		browser.get('http://erpteste.teknisa.com/login/');
		loginPage.login(j.getValor('login'), j.getValor('senha'));
		encargoPage.abrir();
		z.component.footer.clickRightActionByLabel('Filtrar', true);
	});

	afterEach(() => {
		geral.sair();
	});

	it('Deve acessar a tela Encargo', () => {
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${encargoGridId}`)));

		expect(z.component.header.getTitle())
			.toBe('Encargo');
	});

	it('Deve adicionar um encargo', () => {
		geral.clickAdicionar();
		encargoPage.adicionar(j.getValor('codigoEncargo'), j.getValor('nomeEncargo'),
			j.getValor('tratamento'), j.getValor('encargo'));
		geral.clickSalvar();
		geral.filterIt(j.getValor('nomeEncargo'));
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${encargoGridId}`)));

		expect(geral.gridHasText(encargoGridId, j.getValor('nomeEncargo'), 1))
			.toBe(j.getValor('nomeEncargo'));
		expect(geral.gridHasText(encargoGridId, j.getValor('codigoEncargo')))
			.toBe(j.getValor('codigoEncargo'));
	});

	it('Deve editar o encargo', () => {
		geral.clickGrid('CDENCARGO', j.getValor('codigoEncargo'), encargoGridId);
		geral.clickEditar();
		encargoPage.editar(j.getValor('nomeEncargo1'),
			j.getValor('tratamento1'), j.getValor('encargo1'));
		geral.clickSalvar();
		geral.filterIt(j.getValor('nomeEncargo1'));
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${encargoGridId}`)));

		expect(geral.gridHasText(encargoGridId, j.getValor('nomeEncargo1'), 1))
			.toBe(j.getValor('nomeEncargo1'));
		expect(geral.gridHasText(encargoGridId, j.getValor('tratamento1'), 2))
			.toBe(j.getValor('tratamento1'));
	});

	it('Deve excluir o encargo', () => {
		geral.clickGrid('CDENCARGO', j.getValor('codigoEncargo'), encargoGridId);
		geral.clickExcluir();
		geral.clickSim();
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${encargoGridId}`)));

		expect(geral.gridHasText(encargoGridId, j.getValor('nomeEncargo1'), 1))
			.toBeUndefined();
		expect(geral.gridHasText(encargoGridId, j.getValor('codigoEncargo')))
			.toBeUndefined();
	});
});
